loadPath := (!loadPath) 
	  @ ["/import/enterprise/home/ade/work/proj3/src",
	     "/import/enterprise/home/ade/work/unity99"] ;

load "xMECHlogo" ;

(* loading type modules *)

load "TypeDD" ;			
load "TypePP" ;

(* loading Expr modules *)

load "ExprDD"  ;
load "ExprPP"  ;
load "ExprLib" ;

(* loading Expr to HOL syntactical translator *)

load "ExprHol" ;

(* loading PLSEQ modules *)

load "PLSEQDD"    ;
load "PLSEQLib"   ; 
load "PLSEQRules" ;

(* loading PLGA modules *)

load "PLGADD" ;
load "PLGALib" ;
load "PLGAPara" ;
load "PLGARules" ;

(* loading PLPC modules -- just need to borrow some stuffs there to
   parse and represent UNITY specs *)

load "PLPCDD"    ;
load "PLPCPara"  ;
load "PLPCLib"   ;
load "PLPCRules" ;

(* loading static context definition module *)

load "exConst" ;

(* loading HOL libraries *)

load "bossLib";
load "intLib";

(* loading and opening the proof manager *)

load "PLPCManager"  ;
open PLPCManager    ;

open bossLib intLib ;

(* loading and opening tactic Library *)

load "tacticPL"     ;
open tacticPL       ;

(* installing pretty printer ... switch the flag in ppExpr to true if
   you want to make the typing of the expressions to be visible       *)

installPP TypePP.ppType ; 
(*
installPP TypePP.ppType ; 
installPP (ExprPP.ppExpr false) ;
*)

(* creating abbreviations  *) 

val reduceSpec = PLPCRules.reduceLocalSpec ;
val parseS     = PLPCPara.parseS;
val parse      = PLPCPara.parse;
val uih        = PLPCHol.unityInHol false;


(* defining some shortcuts to construct xMECH types *)

val ty_bool	= TypeDD.TyCons ("bool",[]) 		;
val ty_int	= TypeDD.TyCons ("int",[]) 		;
fun ty_array a	= TypeDD.TyCons ("array", [a])		;
fun ty_list  a 	= TypeDD.TyCons ("list", [a])		;
fun ty_chan  a 	= TypeDD.TyCons ("chan", [a])		;


print  (xMECHlogo.xMECHlogo ^ "\n\n" ^
	"Enviroment loaded... you can now continue with the interactive demo.\n\n" );

(*=================================================================================*)



