(*===============================================================
(*DOC

<MODULE>Specification of the One Bit Protocol

<AUTHOR>underdarkPrime and Ade

<DATE>September 2001

<ADDRESS>underdarkPrime@yahoo.com and ade@cs.uu.nl

<DESC>This module provides Some UNITY properties as specifications for
the One Bit Protocol:
 
<UL>

<LI>
<PRE>J:

(SYSLAB.oneBitProtocol.root ==> 
	((senderReady  /\  recReady  ==>  (x=c) /\  (y=c)) /\
	 (~senderReady /\  recReady  ==> ~(x=c) /\  (y=c)) /\
	 ( senderReady /\ ~recReady  ==>  (x=c) /\ ~(y=c)) /\
	 (~senderReady /\ ~recReady  ==> ~(x=c) /\ ~(y=c))))
/\
(SYSLAB.oneBitProtocol.mid ==> senderReady)
/\
(SYSLAB.oneBitProtocol.mid ==> 
	 (( recReady ==> ~(x=c) /\  (y=c)) /\
	  (~recReady ==> ~(x=c) /\ ~(y=c))))</PRE>
</LI>

<LI>
<PRE>progress:

J,System |-- SYSLAB.oneBitProtocol.root /\ senderReady /\ ~recReady 
	     ensures 
	     SYSLAB.oneBitProtocol.root /\ senderReady /\  recReady
	     using
	     {senderReady, recReady} </PRE>
</LI>
</UL>

We actually use a PLPC specification. Since in PLGA we do not have
process class, then the <tt>using</tt> parameter is ignored.

DOC*)
===============================================================*)

J:
|-- stable 
(SYSLAB.oneBitProtocol.root ==> 
	((senderReady  /\  recReady  ==>  (x=c) /\  (y=c)) /\
	 (~senderReady /\  recReady  ==> ~(x=c) /\  (y=c)) /\
	 ( senderReady /\ ~recReady  ==>  (x=c) /\ ~(y=c)) /\
	 (~senderReady /\ ~recReady  ==> ~(x=c) /\ ~(y=c))))
/\
(SYSLAB.oneBitProtocol.mid ==> senderReady)
/\
(SYSLAB.oneBitProtocol.mid ==> 
	 (( recReady ==> ~(x=c) /\  (y=c)) /\
	  (~recReady ==> ~(x=c) /\ ~(y=c))))


PROGRESS1:

J,System |-- SYSLAB.oneBitProtocol.root /\ ~senderReady /\ recReady 
	     ensures 
	     SYSLAB.oneBitProtocol.root /\ senderReady /\  ~recReady
	     using
	     {senderReady, recReady} 




