structure ExprDD = struct	(* DD = Data Definition     *)

(* ============================================================
*
* Author: wishnu@cs.uu.nl
* Version: July 2001
*
============================================================ *)

local 

open TypeDD

in


(* ============================================================
*
* The expression language. Notice that it includes the 
* expression language subset of the specification language, 
* which is typically larger than the one used in the object
* programming language.
*
============================================================ *)

type Identifier 	= string * Type

type VarList 		= Identifier list

datatype Expr =

     Ident 	of Identifier 	

(* literal *)

   | Lit	of Identifier	

(* Examples: 
  
   integer 123 :  Lit ("123", TyCons ("int",[]))

   empty set []:  Lit ("[]" , TyCons ("list", [TyVar "a"]))	              *)

   | ArrayAccess of Expr * Expr 

(* Examples:   X[3] : ArrayAccess (Ident("X",TyCons("list",[TyVar "a"])), 
                                   Lit("3",TyCons("int",[])))                 *)
   | App 	 of Expr * Expr 
   | Unary	 of Identifier * Expr 
   | Binary	 of Identifier * Expr * Expr 
   | Quantor	 of Identifier * VarList * Expr * Expr 
   | Enum	 of Identifier * (Expr list) 
(* added 24 October *)
   | Tuple       of Expr * Expr
  
end
end

