/* One Bit Protocol in Promella ... 

   --Underdark, Ade
*/

/* declaring variables ... with concrete initial values */

bool senderReady = 1 ;
bool recReady    = 1 ;
bool mid = 0 ;

int  x = 0 ;
int  c = 0 ;
int  y = 0 ;


/* updating data --it modelled as non-atomic */

active proctype update()
  {
    do
    :: 	{ 
	(senderReady) -> atomic {x = x+1; mid=1;}	; 
	 atomic {senderReady=0; mid=0;} 		;
	}
    od
  }

/* sending data --it is modelled as atomic */

active proctype send()
  {
    do
    :: 	(recReady && !senderReady) 
	 -> 
	 atomic {c = x 		; 
	         recReady=0 	; 
		 senderReady=1 	; }
    od
  }


/* receiveing data --it is modelled as atomic */

active proctype receive()
  {
    do
    :: (!recReady) 
	 -> 
	 atomic {y = c ; recReady=1 ;} 
    od ;

    /* this statement will never be executed */

    unreachable : y = y - 1			;

  }

active proctype monitor()
{

assert(
(!mid && 
	((senderReady  &&  recReady  &&  (x==c) &&  (y==c)) ||
	 (!senderReady &&  recReady  && !(x==c) &&  (y==c)) ||
	 ( senderReady && !recReady  &&  (x==c) && !(y==c)) ||
	 (!senderReady && !recReady  && !(x==c) && !(y==c))))
||
(mid && senderReady &&
	 (( recReady && !(x==c) &&  (y==c)) ||
	  (!recReady && !(x==c) && !(y==c))))
)
}



/* This is what we actually want to prove:

Shows that this property is stable ...

(~mid ==> 
	((senderReady  /\  recReady  ==>  (x=c) /\  (y=c)) /\
	 (~senderReady /\  recReady  ==> ~(x=c) /\  (y=c)) /\
	 ( senderReady /\ ~recReady  ==>  (x=c) /\ ~(y=c)) /\
	 (~senderReady /\ ~recReady  ==> ~(x=c) /\ ~(y=c))))
/\
(mid ==> senderReady)
/\
(mid ==> 
	 (( recReady ==> ~(x=c) /\  (y=c)) /\
	  (~recReady ==> ~(x=c) /\ ~(y=c))))


But I'm not sure if above is the right way of encoding it in SPIN

*/