structure TypePP :> TypePP = struct

(* ============================================================
(*DOC

<MODULE> TypePP
<AUTHOR> underdarkPrime
<ADDRESS> underdarkPrime@yahoo.com
<DATE> July 2001

<DESC> It provides a pretty printer for values of type TypeDD.Type.

<ITEM>ppType
<TYPE>ppType : ppstream -> TypeDD.Type -> unit

<DESC>The pretty printer can be installed in from the interpreter by
executing the command <tt>installPP ppType</tt> from the interpreter.

DOC*)
============================================================ *)

local

open TypeDD PP 

in

(* ============================================================
*
* Pretty printer for Type
*
============================================================ *)

fun ppTy pps ty = case ty of
	  TyVar a	=> add_string pps a

(* array as function *)
	| TyCons ("array",[t])
			=> (add_string pps "int -> "	;
			    ppTy pps t			)
(*
	| TyCons ("array",[t])
			=> (add_string pps "[]"	;
			    ppTy pps t			)
*)
(*	
	| TyCons ("list",[t])
			=> (add_string pps "["		;
			    ppTy pps t			;
			    add_string pps "]"		)
*)	| TyCons ("list",[t])
			=> (
			    ppTy pps t			;
			    add_string pps " list"	)
	| TyCons ("set",[t])
			=> (add_string pps "{"		;
			    ppTy pps t			;
			    add_string pps "}"		)

	| TyCons ("fun",[t,u])
			=> (add_string pps "("		;
			    ppTy pps t			;
			    add_string pps "->"		;
			    ppTy pps u			;
			    add_string pps ")"		)

	| TyCons ("prod",ts)
			=> (add_string pps "("		;
			    foo pps ts 			;
			    add_string pps ")"		)

	| TyCons (c,[t])=> (ppTy pps t			;
			   add_string pps (" " ^ c)	)

	| TyCons (c,[])	=> add_string pps c

	| TyCons (c,ts) => 				     
		(add_string pps "("			;
		 foo pps ts				;
		 add_string pps (") " ^c)		)

   and

   foo pps [t]    = ppTy pps t
 | foo pps (t::us)= (ppTy pps t 		;
	  	     add_string pps "#" 	;
		     foo pps us			)

fun ppType pps ty = 
	(begin_block pps INCONSISTENT 0		;
	 ppTy pps ty				;
	 end_block pps				)

end

end

