(* ===================================================================== *)
(* FILE          : arrayScript.sml                                       *)
(* DESCRIPTION   : Theorems about array.                                 *)
(*                                                                       *)
(* AUTHOR        : (c) Ade Azurat, University of Utrecht                 *)
(* DATE          : 01.08.22                                              *)
(* ===================================================================== *)

structure arrayScript =
struct


open HolKernel Parse basicHol90Lib ;
(*
Num_conv Num_induct Let_conv
     Prim_rec Type_def_support ;
*)
infix THEN THENL ORELSE;

open listTheory optionTheory 

val _ = new_theory "array";

val _ = bossLib.Hol_datatype `array = ARR of num=>'a list`;

val INDEX_def = bossLib.Define`INDEX x (ARR n l) = if (n< (LENGTH l)) then SOME (EL n l) else NONE`;

(* at this moment we are not supporting finite array,
   finite array will required a new datatype of index
   and required a option type class for its parameter.
   (notion class like in  haskell)

*)
 
val _ = export_theory();

end;

