signature PLPCManager =
sig 
type notes;

(* environement variable needed for the proof manager system *)
val cPath		: string ref
val cName   		: string ref
val specList 		: PLPCDD.SpecList ref
val currentSpec		: (string*PLPCDD.ProcSpec) Option.option ref 
val provenFlag		: bool ref

(* temporal global variable needed for the verification system *)
val procRep             : PLPCDD.ProcClass Option.option ref
val specRep             : PLPCDD.SpecList ref    
val programRep          : string PLGADD.PLGA_Stmt Option.option ref   
val programLab          : (string*string*string) PLGADD.PLGA_Stmt Option.option ref   
val atomics		: (PLSEQDD.Stmt * ExprDD.Expr * (string* string *string)) list ref
val labs_table		: (string * string) list ref
val totalContext 	: (string * TypeDD.Type) list ref
val procContext	        : (string * TypeDD.Type) list ref
val extraContext	: (string * TypeDD.Type) list ref


(* proof manager function *)
val loadProcess 	: string -> string -> unit
val reload 		: unit -> unit
val chooseSpec		: string -> unit


val show		: unit -> PLPCDD.ProcSpec
val showName		: unit -> string


val newSpec             : unit -> unit
val useHol 		: unit -> unit
val confirmProven	: unit -> unit
val dropAll		: unit -> unit
val decomposeSpec       : unit -> unit


(* not for public use *)
val sendToHol 		: (string*PLPCDD.ProcSpec) -> unit
(* val sendUnity 		: PLPCDD.ProcSpec -> unit
ProcSpec -> (string * (string * Type) list) * (string * Expr list) * term
 *)


end
