load "TypeDD" ;			
load "PLSEQDD" ;

load "ExprDD" ;
load "ExprPP" ;
load "ExprLib" ;
load "ExprHol" ;
load "ExprPara" ;

load "PLSEQPara" ;
load "PLSEQRules" ;

load "intLib";

load "listTheory";

load "bossLib";

(* some constant sohoul be loaded *)
(* load "arrayTheory" ; *)
(*
val INDEX_DEF = bossLib.Define`INDEX x n = EL n x`;
*)


(* installPP (ExprPP.ppExpr false) ; *)

val p = PLSEQPara.parse ;

val gen = PLSEQRules.topReduce ;

val sc =
	let
	fun f (v,t,_,_) = (v, TypePara.parseInLine t)
	in 
	map f exConst.context
	end ;

val infer =  ExprLib.tiInfer sc ; 

val hol = ExprHol.exprInHol;

fun fileToHol x = map (hol o fst o infer) (gen (p x))  

fun genOnly x   = map (fst o infer) (gen (p x))  


(* test cases *)

(* case 0: file: sample0.pls *) 

val case0 = fileToHol "./testfile/sample0.pls" ;

set_goal([],hd case0);

e (intLib.COOPER_TAC);


(* case 1: file: sample1.pls *)

val case1 = fileToHol "./testfile/sample1.pls" ;

map (fn (x)=> set_goal([],x)) case1 ;



(* case 2: file: sample2.pls *)

val case2 = fileToHol "./testfile/sample2.pls" ;

map (fn (x)=> set_goal([],x)) case2 ;



(*
open ExprDD ;
open PLSEQRUles ;
open TypeDD ;

val ty_bool 	  = TyCons ("bool",[]) ;
val ty_int	  = TyCons ("int",[]) ;

val ty_bool_unop  = TyCons ("fun", [ty_bool, ty_bool]) ;

val ty_bool_binop = TyCons ("fun", [ty_bool, ty_bool_unop]) ;

val ty_int_binop = TyCons ("fun", [ty_int, TyCons ("fun", [ty_int, ty_int])]) ;

fun mk_imp (p,q) = Binary (("==>",ty_bool_binop), p, q) ;

fun mk_and (p,q) = Binary (("/\\",ty_bool_binop), p, q) ;

fun mk_or (p,q) = Binary (("\\/",ty_bool_binop), p, q) ;

fun mk_not p   = Unary  (("~", ty_bool_unop), p) ;

val mk_T = Lit ("T", ty_bool) ;

fun mk_LT (p,q) = Binary (("<", ty_int_binop), p, q) ;

*)